<?php

defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

if (!class_exists('vmPSPlugin'))
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
class plgVMPaymentSalesautopilot extends vmPSPlugin {

	private $_db 			= null;
	
	function __construct(& $subject, $config) {			

		parent::__construct($subject, $config);			

	}
	
	public function getVmPluginCreateTableSQL() {
		return true;
	}	
	
	function getTableSQLFields() {
		return true;
	}	

	function setParams($method) {		
		return true;
	}
	
	function plgVmConfirmedOrder($cart, $order) {
		if (!class_exists ('VirtueMartModelCategory')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'category.php');
		}
		if (!class_exists ('VirtueMartModelProduct')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'product.php');
		}
		
		$categoryModel	= VmModel::getModel ('Category');		
		$productModel	= VmModel::getModel ('Product');	

		$this->_db = JFactory::getDBO();
		$query = $this->_db->getQuery(true);
		$query->select('slug')
			  ->from('#__virtuemart_shipmentmethods_'.VMLANG)
			  ->where('virtuemart_shipmentmethod_id='.(int)$cart->virtuemart_shipmentmethod_id);
		$this->_db->setQuery($query);
		$shipmentSlug = $this->_db->loadResult();
		
		$query = $this->_db->getQuery(true);
		$query->select('slug')
			  ->from('#__virtuemart_paymentmethods_'.VMLANG)
			  ->where('virtuemart_paymentmethod_id='.(int)$cart->virtuemart_paymentmethod_id);
		$this->_db->setQuery($query);
		$paymentSlug = $this->_db->loadResult();				
	
		$sapData = new stdClass();
		$sapData->email					= $order['details']['BT']->email;
		
		$sapData->mssys_lastname		= $order['details']['BT']->last_name;
		$sapData->mssys_firstname		= $order['details']['BT']->first_name;
		$sapData->mssys_mobile			= $order['details']['BT']->phone_1;
		$sapData->mssys_phone			= $order['details']['BT']->phone_2;
		$sapData->mssys_company			= $order['details']['BT']->company;
		
		$sapData->mssys_postal_company	= $order['details']['ST']->company;
		$sapData->mssys_postal_country	= shopFunctions::getCountryByID( $order['details']['ST']->virtuemart_country_id );
		$sapData->mssys_postal_state	= shopFunctions::getStateByID( $order['details']['ST']->virtuemart_state_id );
		$sapData->mssys_postal_city		= $order['details']['ST']->city;
		$sapData->mssys_postal_address	= implode( ' ', array($order['details']['ST']->address_1, $order['details']['ST']->address_2) );		
		$sapData->mssys_postal_zip		= $order['details']['ST']->zip;
		
		$sapData->mssys_bill_company	= $order['details']['BT']->company;
		$sapData->mssys_bill_country	= shopFunctions::getCountryByID( $order['details']['BT']->virtuemart_country_id );
		$sapData->mssys_bill_state		= shopFunctions::getStateByID( $order['details']['BT']->virtuemart_state_id );
		$sapData->mssys_bill_city		= $order['details']['BT']->city;
		$sapData->mssys_bill_address	= implode( ' ', array($order['details']['BT']->address_1, $order['details']['BT']->address_2) );		
		$sapData->mssys_bill_zip		= $order['details']['BT']->zip;
		
		$sapData->mssys_coupon			= $order['details']['BT']->coupon_code;
			
		$sapData->shipping_method		= $shipmentSlug;
		$sapData->payment_method		= $paymentSlug;

		$sapData->currency				= shopFunctions::getCurrencyByID( $order['details']['BT']->order_currency, 'currency_code_3' );
		$sapData->netshippingcost		= round( $order['details']['BT']->order_shipment );
		$sapData->grossshippingcost		= round( $order['details']['BT']->order_shipment + $order['details']['BT']->order_shipment_tax );
		$sapData->order_id				= $order['details']['BT']->order_number;
		$sapData->products				= Array();
		
		foreach($order['items'] as $item)
		{		
			$vmProduct	= $productModel->getProduct($item->virtuemart_product_id);
			$p	= new stdClass();
			$p->prod_id			= $item->virtuemart_product_id;
			$p->prod_name		= $item->order_item_name;
			$p->category_id		= $item->virtuemart_category_id;
			$p->category_name	= $categoryModel->getCategory($item->virtuemart_category_id)->category_name;
			
			if (isset($item->product_discountedPriceWithoutTax) && $item->product_discountedPriceWithoutTax > 0) {
				$p->prod_price = round( $item->product_discountedPriceWithoutTax, 2 );
			} else {
				$p->prod_price = round( $item->product_priceWithoutTax, 2 );
			}

			$p->tax				= round( $item->product_tax / $item->product_priceWithoutTax * 100, 2 );
			$p->qty				= $item->product_quantity;
			
			$sapData->products[] = $p;
		}

		$url = 'http://restapi.emesz.com/processWebshopOrder/'.$this->params->get('salesautopilot_nlid').'/ns_id/'.$this->params->get('salesautopilot_nsid');
		$ch = curl_init($url); 
		$data_string	= json_encode( $sapData );		
		
		curl_setopt($ch, CURLOPT_USERPWD, $this->params->get('salesautopilot_username').':'.$this->params->get('salesautopilot_password') );
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);                                                                  
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
		curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
			'Content-Type: application/json',                                                                                
			'Content-Length: ' . strlen($data_string))                                                                       
		);                                                                                                                   
		 
		$result = curl_exec($ch);
		
		$http_status = curl_getinfo($ch, CURLINFO_HTTP_CODE);
 
		return true;
	}
	
	protected function utf2ISO8859($string) {
	  return $string;
	}
	
	protected function convert($string){
		return $string;
	  return iconv('ISO-8859-2', 'UTF-8', $this->convertBack($string));
	}

	protected function convertBack($string){
	  return iconv('UTF-8', 'ISO-8859-2//TRANSLIT', $string);
	}
	

	protected function checkConditions($cart, $method, $cart_prices){

		return false;
	}
	
	
	function plgVmOnPaymentResponseReceived(&$html) {	
	
		return false;
	}
		
	/**
	* We must reimplement this triggers for joomla 1.7
	*/
	
	/**
	 * Create the table for this plugin if it does not yet exist.
	 * This functions checks if the called plugin is active one.
	 * When yes it is calling the standard method to create the tables
	 * @author Valérie Isaksen
	 *
	 */
	function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {
	
		return $this->onStoreInstallPluginTable($jplugin_id);
	}
	
	/**
	 * This event is fired after the payment method has been selected. It can be used to store
	 * additional payment info in the cart.
	 *
	 * @author Max Milbers
	 * @author Valérie isaksen
	 *
	 * @param VirtueMartCart $cart: the actual cart
	 * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
	 *
	 */
	public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
		return $this->OnSelectCheck($cart);
	}
	
	/**
	 * plgVmDisplayListFEPayment
	 * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
	 *
	 * @param object $cart Cart object
	 * @param integer $selected ID of the method selected
	 * @return boolean True on succes, false on failures, null when this plugin was not selected.
	 * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
	 *
	 * @author Valerie Isaksen
	 * @author Max Milbers
	 */
	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		return $this->displayListFE($cart, $selected, $htmlIn);
	}
	
	/*
	 * plgVmonSelectedCalculatePricePayment
	* Calculate the price (value, tax_id) of the selected method
	* It is called by the calculator
	* This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
	* @author Valerie Isaksen
	* @cart: VirtueMartCart the current cart
	* @cart_prices: array the new cart prices
	* @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
	*
	*
	*/
	
	public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, &$cart_prices, &$cart_prices_name) {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
	}
	
	/**
	 * plgVmOnCheckAutomaticSelectedPayment
	 * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
	 * The plugin must check first if it is the correct type
	 * @author Valerie Isaksen
	 * @param VirtueMartCart cart: the cart object
	 * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
	 *
	 */
	function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, $cart_prices = array()) {
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
	}
	
	/**
	 * This method is fired when showing the order details in the frontend.
	 * It displays the method-specific data.
	 *
	 * @param integer $order_id The order ID
	 * @return mixed Null for methods that aren't active, text (HTML) otherwise
	 * @author Max Milbers
	 * @author Valerie Isaksen
	 */
	public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}
	
	protected function onShowOrderFE($virtuemart_order_id, $virtuemart_method_id, &$method_info) {
		if (!($this->selectedThisByMethodId($virtuemart_method_id))) {
			return null;
		}
		$method_info = $this->getOrderMethodNamebyOrderId($virtuemart_order_id);
	}
	
	private function getOrderMethodNamebyOrderId($virtuemart_order_id) {
		$lang =& JFactory::getLanguage();
		$tag = $lang->getTag();
		$tag = strtolower($tag);
		
		$db = JFactory::getDBO();
		$query = 'SELECT virtuemart_paymentmethod_id FROM #__virtuemart_orders WHERE virtuemart_order_id="'.$virtuemart_order_id.'"';
		$db->setQuery($query);
		$paymentMethodId = $db->loadObject();
		
		$query = 'SELECT payment_name FROM #__virtuemart_paymentmethods_'.$tag.' WHERE virtuemart_paymentmethod_id ="'.$paymentMethodId->virtuemart_paymentmethod_id.'"';
		$db->setQuery($query);
		$paymentName = $db->loadObject();
		
		if(isset($paymentName->payment_name)){
			return $paymentName->payment_name;
		}else{
			$query = 'SELECT payment_name FROM #__virtuemart_paymentmethods_hu_hu WHERE virtuemart_paymentmethod_id ="'.$paymentMethodId->virtuemart_paymentmethod_id.'"';
			$db->setQuery($query);
			$paymentName = $db->loadObject();
			
			if(isset($paymentName->payment_name)){
				return $paymentName->payment_name;
			}else{
				$query = 'SELECT payment_name FROM #__virtuemart_paymentmethods_en_gb WHERE virtuemart_paymentmethod_id ="'.$paymentMethodId->virtuemart_paymentmethod_id.'"';
				$db->setQuery($query);
				$paymentName = $db->loadObject();
					
				if(isset($paymentName->payment_name)){
					return $paymentName->payment_name;
				}else{
					return 'Bankkártyás fizetés';
				}
			}
		}
	}
	
	/**
	 * This event is fired during the checkout process. It can be used to validate the
	 * method data as entered by the user.
	 *
	 * @return boolean True when the data was valid, false otherwise. If the plugin is not activated, it should return null.
	 * @author Max Milbers
	
	 public function plgVmOnCheckoutCheckDataPayment($psType, VirtueMartCart $cart) {
	 return null;
	 }
	 */
	
	/**
	 * This method is fired when showing when priting an Order
	 * It displays the the payment method-specific data.
	 *
	 * @param integer $_virtuemart_order_id The order ID
	 * @param integer $method_id  method used for this order
	 * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
	 * @author Valerie Isaksen
	 */
	function plgVmonShowOrderPrintPayment($order_number, $method_id) {
		return $this->onShowOrderPrint($order_number, $method_id);
	}
	
	/**
	 * Save updated order data to the method specific table
	 *
	 * @param array $_formData Form data
	 * @return mixed, True on success, false on failures (the rest of the save-process will be
	 * skipped!), or null when this method is not actived.
	 * @author Oscar van Eijk
	
	 public function plgVmOnUpdateOrderPayment(  $_formData) {
	 return null;
	 }
	 */
	/**
	 * Save updated orderline data to the method specific table
	 *
	 * @param array $_formData Form data
	 * @return mixed, True on success, false on failures (the rest of the save-process will be
	 * skipped!), or null when this method is not actived.
	 * @author Oscar van Eijk
	
	 public function plgVmOnUpdateOrderLine(  $_formData) {
	 return null;
	 }
	 */
	/**
	 * plgVmOnEditOrderLineBE
	 * This method is fired when editing the order line details in the backend.
	 * It can be used to add line specific package codes
	 *
	 * @param integer $_orderId The order ID
	 * @param integer $_lineId
	 * @return mixed Null for method that aren't active, text (HTML) otherwise
	 * @author Oscar van Eijk
	
	 public function plgVmOnEditOrderLineBE(  $_orderId, $_lineId) {
	 return null;
	 }
	 */
	
	/**
	 * This method is fired when showing the order details in the frontend, for every orderline.
	 * It can be used to display line specific package codes, e.g. with a link to external tracking and
	 * tracing systems
	 *
	 * @param integer $_orderId The order ID
	 * @param integer $_lineId
	 * @return mixed Null for method that aren't active, text (HTML) otherwise
	 * @author Oscar van Eijk
	
	 public function plgVmOnShowOrderLineFE(  $_orderId, $_lineId) {
	 return null;
	 }
	 */
	function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
		return $this->declarePluginParams('payment', $name, $id, $data);
	}
	
	function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
		return $this->setOnTablePluginParams($name, $id, $table);
	}
	
}